﻿using Syncfusion.UI.Xaml.TreeGrid.Helpers;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Syncfusion.UI.Xaml.Grid.Helpers;
using Syncfusion.UI.Xaml.TreeGrid;
using Syncfusion.UI.Xaml.ScrollAxis;
using Windows.UI;
using System.Collections.ObjectModel;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace App1
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            this.Loaded += OnLoaded;
        }
        void OnLoaded(object sender, RoutedEventArgs e)
        {
            var viewModel = this.DataContext as EmployeeRepository;
            viewModel.filterChanged = OnFilterChanged;
        }

        private void OnFilterChanged()
        {
            var viewModel = this.DataContext as EmployeeRepository;
            if (treeGrid.View != null)
            {
                treeGrid.View.Filter = viewModel.FilerRecords;
                treeGrid.View.RefreshFilter();
            }
        }

        ObservableCollection<Employee> view = null;
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            view = (this.treeGrid.DataContext as EmployeeRepository).EmployeeDetails;
            view.Insert(0, new Employee() { FirstName="", LastName="", EmployeeID =0 , City="", Salary=0.0 });
        }
    }

    public class SearchConditionVisibilityConverter : IValueConverter
    {
        /// <summary>
        /// Convert value to Visibility
        /// </summary>
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            var index = value as int?;
            string text = parameter.ToString();
            if (text.Equals("SearchCondition"))
            {
                if (index > 0)
                    return Visibility.Visible;
            }
            else if (text.Equals("NumericComboBox"))
            {
                if (index == 3 || index == 6)
                    return Visibility.Visible;
            }
            else if (text.Equals("StringComboBox"))
            {
                if (index == 1 || index == 2 || index == 4 || index == 5)
                    return Visibility.Visible;
            }
            return Visibility.Collapsed;
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }

    public class FilterLevelConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            int? index = value as int?;
            if (index == 0)
                return FilterLevel.All;
            else if (index == 1)
                return FilterLevel.Root;
            else
                return FilterLevel.Extended;
        }
        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }
}

